commit 5d4e9c7043cdda9651353d6c5d56a0522a397ad2
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Fri Dec 13 20:50:44 2024 +0100

    ada: Fix small thinko in previous change to two-pass aggregate expansion
    
    We need a type tailored to the base index type to compute the length.
    
    gcc/ada/ChangeLog:
    
            * exp_aggr.adb (Two_Pass_Aggregate_Expansion): Use the base type of
            the index type to find the type used to compute the length.

diff --git a/gcc/ada/exp_aggr.adb b/gcc/ada/exp_aggr.adb
index 26b279701e9..b74267b299c 100644
--- a/gcc/ada/exp_aggr.adb
+++ b/gcc/ada/exp_aggr.adb
@@ -5704,10 +5704,11 @@ package body Exp_Aggr is
          Comp_Type  : constant Entity_Id := Etype (N);
          Index_Id   : constant Entity_Id := Make_Temporary (Loc, 'I', N);
          Index_Type : constant Entity_Id := Etype (First_Index (Etype (N)));
+         Index_Base : constant Entity_Id := Base_Type (Index_Type);
          Size_Id    : constant Entity_Id := Make_Temporary (Loc, 'I', N);
          Size_Type  : constant Entity_Id :=
                         Integer_Type_For
-                          (Esize (Index_Type), Is_Unsigned_Type (Index_Type));
+                          (Esize (Index_Base), Is_Unsigned_Type (Index_Base));
          TmpE       : constant Entity_Id := Make_Temporary (Loc, 'A', N);
 
          Assoc    : Node_Id := First (Component_Associations (N));

